// straddis.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "straddis.h"

#include "mainfrm.h"
#include "straddoc.h"
#include "stradvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSDisApp

BEGIN_MESSAGE_MAP(CSDisApp, CWinApp)
	//{{AFX_MSG_MAP(CSDisApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// NO Standard file based document commands
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDisApp construction

CSDisApp::CSDisApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSDisApp object

CSDisApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDisApp initialization

BOOL CSDisApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_ASEXTYPE,
		RUNTIME_CLASS(CSDisDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CSDisView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();


	// create a new (empty) CSDisDoc document
	if (m_templateList.GetCount() != 1)
	{
		TRACE0("Error : CSDisDoc not registered with CWinApp\n");
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		return FALSE;
	}

	CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetHead();

	ASSERT(pTemplate != NULL);
	ASSERT(pTemplate->IsKindOf(RUNTIME_CLASS(CDocTemplate)));

	CSDisDoc* pDisplayDoc = (CSDisDoc*) pTemplate->OpenDocumentFile(NULL);
		// if returns NULL, the user has already been alerted

	// Application initial status from command line processing
	if (pDisplayDoc != NULL) {
		BOOL bAserverConnect;
		LPSTR lpAserverCommand;

		// Use second argument to indicate we were started from the ASERVER
		// First argument will be the program name which we ignore
		char TESTARG[] = "ASERVER:";

		char* pSecond = strchr (m_lpCmdLine, ' ');
		if (pSecond != NULL) {
			pSecond++;
			bAserverConnect = strncmp (pSecond, TESTARG, strlen(TESTARG)) == 0;

			// Find Directory name, strip trailing space which apears when started by ASERVER
			lpAserverCommand = pSecond + strlen(TESTARG);
			char* pSpace = strchr (lpAserverCommand, ' ');
			if (pSpace != NULL)
				*pSpace = '\0';    
		}
		else
			bAserverConnect = FALSE;

		if (bAserverConnect) {   
			// Everything is created: pass on Aserver command line setup to document
			pDisplayDoc->AserverConnect (lpAserverCommand);
		}
		else {
			// Warn we are not connected
			CString message = "Not Connected to Aserver, check command line\n";
			message += m_lpCmdLine;
			AfxMessageBox (message);
		}
        
		return TRUE;
	}// Initialise pDisplayDoc
	
	else
		return FALSE;

}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSDisApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSDisApp commands
