/*
 * Implementation of CTestServer
 * Handle test communciations using the ASERVER protocol
 */

#include "stdafx.h"
#include "testserv.h"



CTestServer::CTestServer () : CAserver (1, MAX_TESTMESSAGE, 10)
{                               
	m_bReceived = FALSE;
}   

CTestServer::~CTestServer ()
{
}


void CTestServer::SendStatus (BOOL bStop)
{
	char Status[MAX_TESTMESSAGE];
	char Stop[MAX_TESTMESSAGE] = "Stop";
	
	if (bStop)
		SendMessage (0, Stop, strlen(Stop));
	else {
		for (int i = 0; i < 1000; i++) {
			sprintf (Status, "Status %d", i);
			SendMessage (0, Status, strlen(Status));
		}
	}
}


LPSTR CTestServer::StatusString ()
/* Retrive pointer to a formated status string */
{                           
	static char strStatus[80];
    
    if (m_bReceived) {
    	sprintf (strStatus, "%79s", m_TestString);
	}
	else
		sprintf (strStatus, "No Test Data");
		
	return strStatus;
}



BOOL CTestServer::RecMessage (int c_num, const void* pMessage, UINT size)
/* Process a vehicle Status Message */
{   
	memcpy (&m_TestString, pMessage, size);     
	m_TestString[size] = '\0';
	m_bReceived = TRUE;
	
	return TRUE;	// Received message processing completed
}


void CTestServer::ProtocolFail (const char* errorText)
/*
 * A fatal protocol error occured, just display the recomended errorText
 */
{
	AfxMessageBox (errorText, MB_ICONEXCLAMATION);
}


void CTestServer::ConnectionInfo (int c_num, int result, const packet_hdr hdr, BOOL sigInt, const char* service, const char* serviceParam)
/*
 * Connection Information, display informative text
 */
{
	if (sigInt)
	{
		AfxMessageBox  ("ASERVER Shutdown", MB_ICONEXCLAMATION);
	}
	
	else {
		switch (result) {
			case ASRC_SUCCESS:
				AfxMessageBox  ("ASERVER Connection", MB_ICONEXCLAMATION);
			break;
			
			case ASRC_GOT_DISCONNECT_REQ:
				AfxMessageBox  ("ASERVER Disconnected", MB_ICONEXCLAMATION);
			break;
	
			case ASRC_GOT_ABORT_REQ:
				AfxMessageBox  ("ASERVER Connection Abort", MB_ICONEXCLAMATION);
			break;
				
			case ASRC_TX_ERROR:
				AfxMessageBox ("ASERVER Error flag set", MB_ICONEXCLAMATION);
			break;
			
			case ASRC_RESTART:
				AfxMessageBox ("ASERVER debugger terminated", MB_ICONEXCLAMATION);
			break;              
			
			case ASRC_TERMINATE:
				AfxMessageBox ("ASERVER debugger terminated", MB_ICONEXCLAMATION);
			break;
			
			default:
			break;
		}// switch hdr_type
	}// hdr_type		
}
